// Copyright (c) 2023 Dominic Masters
// 
// This software is released under the MIT License.
// https://opensource.org/licenses/MIT

#pragma once
#include "scene/components/display/Material.hpp"

namespace Dawn {
  class SimpleTexturedMaterial : public Material {
    public:
      Texture *texture = nullptr;
      struct Color color = COLOR_WHITE;

      /**
       * SimpleTexturedShader scene item component interface.
       * 
       * @param i Scene Item this interface belongs to.
       */
      SimpleTexturedMaterial(SceneItem *i);
      
      Shader * getShader() override;
  };
}